#!/bin/bash

#updates by WIBOON 2556-01-21

#Add multiple users with bulk import
#You can import multiple users into PSU-netdrive file server from a single file source. The file must be a text file and adhere to the required format. 
#For example 
#Filename: usergroup1
#user01
#user02
#user03
#
#When finished, the original filename will be replace with a filename_timestamp.csv consists of lines with username:password format.

if [ -z "$(id -nG|grep -w "root")" ] ; then
  echo "need root, or try: sudo sh $0"
  exit
fi

if [ -z "$1" ] ; then
  echo "need filename,"
  echo "if filename is usergroup1, try: sudo sh $0 usergroup1"
  echo "a file consists of one username per line i.e."
  echo "user01"
  echo "user02"
  exit 
fi

TODAY=$(date "+%Y%m%d%H%M")
IN_FILENAME=$1
HOME_DIR="/sftp/home"
OUT_FILENAME=${IN_FILENAME}_${TODAY}.csv

if [ ! -f ${IN_FILENAME} ] ; then
  echo "File not found"
  exit
fi

sudo touch ${OUT_FILENAME}

for USERDETAILS in `cat ${IN_FILENAME}`
do
  MYUSER=`echo ${USERDETAILS}`
  PASSWD=`apg -n 1 -a 1 -M nL -m 10 -x 10 -E ijl0oqg`
  echo "...Processing adding user ${MYUSER}"
  sudo useradd -m -b ${HOME_DIR} -s /bin/bash -p `mkpasswd ${PASSWD}` ${MYUSER}
  if [ $? -eq 0 ] ; then
    echo "+Added user ${MYUSER} with password ${PASSWD}"
    sudo echo "${MYUSER}:${PASSWD}" >> ${OUT_FILENAME}
    sudo chmod -R o-rwx ${HOME_DIR}/${MYUSER}
    sudo gpasswd -a ${MYUSER} member
    sudo gpasswd -a ${MYUSER} sftponly
  else
    sudo echo "${MYUSER}:invalid" >> ${OUT_FILENAME}
  fi
done
sudo chmod go-rwx ${OUT_FILENAME}
sudo rm -f ${IN_FILENAME}
echo "Finished, the original filename ${IN_FILENAME} replaced with ${OUT_FILENAME} consists of lines with username:password format."

#END
