#!/bin/bash

#updates by WIBOON 2556-01-21

#Delete multiple users
#You can delete multiple users from PSU-netdrive file server from a single file source. The file must be a text file and adhere to the required format. 
#For example 
#Filename: usergroup1
#user01
#user02
#user03
#
#When finished, the original filename will be replace with a filename_timestamp.csv consists of lines with username:status format.

if [ -z "$(id -nG|grep -w "root")" ] ; then
  echo "need root, or try: sudo sh $0"
  exit
fi

if [ -z "$1" ] ; then
  echo "need filename,"
  echo "if filename is usergroup1, try: sudo sh $0 usergroup1"
  echo "a file consists of one username per line i.e."
  echo "user01"
  echo "user02"
  exit 
fi

TODAY=$(date "+%Y%m%d%H%M")
IN_FILENAME=$1
HOME_DIR="/sftp/home"
OUT_FILENAME=${IN_FILENAME}_${TODAY}_del.csv

if [ ! -f ${IN_FILENAME} ] ; then
  echo "File not found"
  exit
fi

sudo touch ${OUT_FILENAME}

for USERDETAILS in `cat ${IN_FILENAME}`
do
  MYUSER=`echo ${USERDETAILS}`
  echo "...Processing deleting user ${MYUSER}"
  sudo gpasswd -d ${MYUSER} member
  sudo gpasswd -d ${MYUSER} sftponly
  sudo userdel -r ${MYUSER} 
  if [ $? -eq 0 ] ; then
    echo "Deleted user ${MYUSER}"
    sudo echo "${MYUSER}:deleted" >> ${OUT_FILENAME}
  else
    sudo echo "${MYUSER}:invalid" >> ${OUT_FILENAME}
  fi
done
sudo chmod go-rwx ${OUT_FILENAME}
sudo rm -f ${IN_FILENAME}
echo "Finished, the original filename ${IN_FILENAME} replaced with ${OUT_FILENAME} consists of lines with username:status format."

#END
